︠004dabb0-668f-4b13-bfa3-62f438afb7b0s︠
reset
︡966fd8d1-b37a-4e92-87b8-48f8d9ff9e2c︡{"stdout":"<function reset at 0x7f38ea66e0c8>\n"}︡{"done":true}
︠ec4f9a5e-f4dc-4b15-9880-f725575871eas︠
#Exercise 1
#Let g(x)=(1/2)(x+2/x). Consider the simple iteration process x[k+1] = g(x[k]), with initial guess x[0]=a>0.
#(a) Plot the graph of g(x) and the line y = x for in one figure to verify that the positive fixed point p exists. Experiment with initial guess to get a figure showing fixed point.
#(b) Find algebraically the largest set for initial guess (it is called the basin of attaraction) that guarantees convergence of the iteration process.
#(c) Find the positive fixed point exactly.
#(d) Plot in one figure the function g(x), y=x, three iteration points (k, x[k]), k=1..3, with initial guess of your choice, and the fixed point p.
︡79171ea8-d874-4ee9-b07d-cb59d7da18f4︡{"done":true}
︠13a0f934-1658-443b-be7f-af95cb838670s︠
g(x)=(1/2)*(x+2/x)
︡f1c0ef28-4811-45ff-b6b6-b51a319b5a33︡{"done":true}
︠15d0b98e-7529-4571-b50a-d999182cd870s︠
#(a)

f_plot=plot(g,0.5,5,figsize=[4,3])
line_plot=line([(0,0), (5,5)])# Learn syntax of the SageMath command line
(f_plot+line_plot).show()
︡2efeec53-7a74-4110-b533-0656150fe57e︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/690/tmp_nM28I0.svg","show":true,"text":null,"uuid":"1925204b-6c21-4e69-9bdb-13f652be6235"},"once":false}︡{"done":true}
︠dbf282f8-bdbc-4e1d-88c0-2d0f91b72462s︠
#(b)
# Your work goes here
#x=(sqr(2/3),2i)

#(c)
# Your work goes here
# x^*=sqr(2)

#(d)
# Your work goes here

#############################
︡e410dc12-465d-4f82-b4a2-6905d41e555a︡{"done":true}
︠d2e52cd3-aa93-4073-88e0-72133cc15135s︠
#Exercise 2. Make a function simple_iteration(g, a, n) that takes function g, an initial value a, and a positive integer n and returns a list of n iteration points for the fixed point problem x[n+1]=g(x[n]).
#Test your function on the problem in Exercise 1.
︡3e614974-7996-4d89-9377-de52003f5e54︡{"done":true}
︠3e375344-130e-4ab5-aa81-5a1f3ba6c0c6s︠
def simple_iteration(g,a,n):
    L=[a]
    for j in range(n):
        temp=g(L[j-1]).n()# Encode the iteration formula here
        L.append(temp)
    return L

#My example
simple_iteration(g,5,7)

︡526a0b8a-1f7a-414a-b1cc-24c0d69c2829︡{"stdout":"[5, 2.70000000000000, 2.70000000000000, 1.72037037037037, 1.72037037037037, 1.44145536817765, 1.44145536817765, 1.41447098136777]\n"}︡{"done":true}
︠4e94fb77-21d2-4dca-8dfc-2a5f94eb5385s︠
#Your example
simple_iteration(g,2,9)

︡2f6eb922-b2c4-45cb-9723-3871d9436eb1︡{"stdout":"[2, 1.50000000000000, 1.50000000000000, 1.41666666666667, 1.41666666666667, 1.41421568627451, 1.41421568627451, 1.41421356237469, 1.41421356237469, 1.41421356237309]\n"}︡{"done":true}
︠1442dfba-901b-437a-9def-f948063b7bf9s︠
######################################

︡6fead946-1b54-4521-9c4f-eb3fff9da77d︡{"done":true}
︠699f498d-c841-49ba-97c0-87cc594f5d3fs︠
#Demo: Recursive function for finding nth iterate of the fixed point problem
def nth_iterate(f,a,n):
    b=a
    if n==0:
        return b
    else:
        b=f(b)
        return (nth_iterate(f,b,n-1)).n()

nth_iterate(g,5,4)

︡4aecb667-2852-4628-8d07-55dca88a5ede︡{"stdout":"1.41447098136777\n"}︡{"done":true}
︠30b17bb9-8736-4b6d-b01a-0f9909643069s︠
############################
︡619f1916-f015-46be-9d08-c94b0d7a61d5︡{"done":true}
︠82a46c5d-fd1d-4a4e-92d9-d886aff2b7dds︠
#Exercise 3. Modify the fixed point problem in Example 3(b) (see Lecture 8) to design a fixed point iteration process that converges to the root x=-1.697471881. Run the function n_iterates  that you made in Exercise 2 to find ten iteration points. Make a figure similar to Fig. 8.1 with these points.
︡75362245-fd19-41dd-811a-2ae761fb9080︡{"done":true}
︠d99bca27-e9d1-4082-8003-96990bee1f46s︠
###########################
︡59833f59-ec83-4011-9d21-32b7591e3bf1︡{"done":true}
︠b2bce353-5dd3-47a2-8aef-1f27dab34c04︠
#Exercise 4. For one of the functions in Exercise 4 (see Lecture 8) (your choice), do the following.
#(a) Transform the equation into a fixed point problems of the form x=g(x).
#(b) Plot functions y = x, y = g(x) in one figure. Choose a range that incudes the fixed point.
#(c) By visual inspection of the figure that you have made, estimate location of the fixed point and find an interval of initial guess values that ensure convergence of the simpe iteration procedure x[n+1]=g(x[n]). Choose initial guess x0=a in this interval and run the function simple_iteration(g, xini, n) to find ten iteration points. Make a figure similar to Fig. 8.1 in Lecture 8 with these points.
︡4dada9a5-435f-4bbe-8913-da7e8ea5d2fc︡{"done":true}
︠86edddac-9d9e-495a-8fed-28f4e85a754as︠
#(a) Your work goes here
var('x')
g(x)=sin(x)-1/2
︡c0f1e25f-d1c1-4f11-98b5-9da120e2829a︡{"stdout":"x\n"}︡{"done":true}
︠4b6b3556-c258-492a-bb4e-b449945578des︠
#(b) Your work goes here
f_plot=plot(g(x),-3,x,3)
︡252854e9-2a41-40e4-b699-b4b8e66f96d1︡{"done":true}
︠5f3e33c6-63b9-48f0-b266-cf80151bbea4s︠
#(c) # Your work goes here
f_plot=plot(g(x),-3,x,3);
line_plot=plot(x,-3,3);
(line_plot+f_plot).show()
Approx=simple_iteration(g,5,10);Approx
︡a125900f-95bd-4f64-a6a9-04e10e7aca0f︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/690/tmp_1lX4qQ.svg","show":true,"text":null,"uuid":"0c3c80eb-7b74-4a9b-ba7e-da70fce477d4"},"once":false}︡{"stdout":"[5, -1.45892427466314, -1.45892427466314, -1.49374884567622, -1.49374884567622, -1.49703331086228, -1.49703331086228, -1.49728074202868, -1.49728074202868, -1.49729894622341, -1.49729894622341]\n"}︡{"done":true}
︠c6d16f74-de5e-4754-bc2e-56be85deb9a6︠

︡7287ad5a-4415-4b96-8539-7aa97826f046︡
︠605336fa-62c3-4f86-acf0-df100ff45ad9︠
########################
︡de2e2b05-aa6f-481b-b228-4404fe2f0b63︡
︠9406e77d-0347-47f7-a6a8-cc16b560f606s︠

# Exercise 5: Newton's method
# Your code takes a function, its derivative, and the initial guess x0=a for a root of the equation f(x)=0. Manual and mental work is needed before running the function in order to choose an initial guess that ensures convergence of the method.
#You may choose different stopping criterion
    # Complete the code
    
def my_newton(f,a,n):
    L=[a]
    fprime=diff(f,x)
    for j in range(1,n):
        newx=(L[j-1])-(f(L[j-1])/fprime(L[j-1]))
        L.append(newx)
    return(my_newtown(f,a,n))
︡e01f79a5-87cf-43f0-8e86-ebd2a3957ed4︡{"done":true}
︠71e4704f-17ac-4c27-9b19-705e2d16d492s︠
# Useful command: Finding index of an element in a list
L=[1,2,3,4];2 in L
︡7d20fd64-26b8-4d9e-9ba2-9446837c8ff6︡{"stdout":"True\n"}︡{"done":true}
︠652a5462-2747-4c7d-b4f6-7d38462113b8s︠
L.index(2)
︡2ed40de5-9c3b-48d3-9964-794e8eedcb5b︡{"stdout":"1\n"}︡{"done":true}
︠77f9d3db-b61e-4ef5-9e05-581ffa2bae4as︠
#Demo (FYI): Finding cube root of x, 0<x<125, by Newton's method
#Note that for x>0 the function x^3-c is growing and concave up. By the rule of thumb, given an interval of the root isolation, the initial guess is set to the right end of the interval.
def cube_root(c,eps):
    L=[j^3 for j in range(1,6)]# List of j^3 to bracket c between two concecutive cubes
    if c in L:
        return L.index(c)+1
    else:
        # Bracket x between two consecutive elements of L
        for j in range(1,5):
            if c<L[j]:
                xold=N(L[j]);xnew=xold-(xold^3-c)/(3.0*xold^2)# MR formula is encoded here
        # Apply Newton's method
        while abs(xold-xnew)>eps:
            xold=xnew
            xnew=xold-(xold^3-c)/(3.0*xold^2)
        return xnew
︡5f821a05-362f-4473-a874-0ac114d46146︡{"done":true}
︠cda3ad3e-d409-4ba3-aa03-10d29b3b1fdfs︠
cube_root(83,10^(-3))
︡c52d8815-3dbc-4773-961f-7168e045d476︡{"stdout":"4.36207067174020\n"}︡{"done":true}
︠3f3e4215-3e84-433b-af22-35589e9db28cs︠
83.^(1/3)
︡a37afede-bc39-44c6-abf6-e7c19231a80f︡{"stdout":"4.36207067145484\n"}︡{"done":true}
︠5c2081a0-8520-4e47-9646-4fb9f0cf585f︠
######################################
︡f79888f2-acee-4220-a570-8daeeaf0adf2︡{"done":true}
︠d76526ae-7b0a-4f85-a31d-8b1f2716a6c5︠

︡c6b9334d-a406-4693-b277-c53d0d717f00︡
︠f538dbce-bebc-49ab-9e0d-3267c62b4ceds︠
# Lab (optional): Exploration of the logistic maps
#Follow the directions in Lecture 8.

# Help file
#//Inputs: Logistic map f_r(x),initial guess u0,number of iterations n
#//Input: range for x: xmin, xmax for plotting
#//Output: cobweb for f(x)
def snail(f,x,u0,n,xmin,xmax):
    u = u0
    P = plot(x, (x, xmin, xmax), color='gray',figsize=[5,3])
    for i in range(n):
        #Learn about command "line" to undertand the plot added to P
        P += line([[u,u],[u,f(u)],[f(u),f(u)]], color = 'red')
        u = f(u)
    P += f.plot(x, xmin, xmax, color='blue')
    P.show()
︡36c8e83a-03d1-4434-b96c-ab4c5dbaa538︡{"done":true}
︠a0b9a654-2c71-46cb-b2c5-038f3571ecc8︠











